/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.baselibs;

import cdac.medinfo.sdk.hl7282.baselibs.segmentfactory.DataElementFactory;
import cdac.medinfo.sdk.hl7282.commoninterface.IDataType;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidComponentTypeException;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidDataTypeException;
import cdac.medinfo.sdk.hl7282.exceptions.MissingValueException;
import cdac.medinfo.sdk.hl7282.utils.EnumDataType;
import cdac.medinfo.sdk.hl7282.utils.IDataTypeMap;

/**
 * MOP - Money or Percentage<p>
 * This data type specifies an amount that may be 
 * either currency or a percentage. It is a variation on the MO data type 
 * that is limited to currency.
 * <p>Represents an HL7 MOP data type. 
 * This data type has the following attributes:</p><p>
 *  1. Money or Percentage Indicator (ID)<b>Required</b><br>
 *  2. Money or Percentage Quantity (NM)<b>Required</b><br>
 *  3. Currency Denomination (ID)<b>Optional</b><br><p>
 * This class provides accessors & mutators for the elements mentioned above.
 * This class override the equal method, to check whether some other object is "equal to" this one.
 * 
 * <p>User can also create Data Type through {@link DataElementFactory} 
 */
public class MOP extends CompositeDataType   
{
	


	/**
	 * Default Constructor for MOP
	 */
	public MOP()
	{
		super(EnumDataType.HL7_DT_MOP);
		 
	}

	/**
	 * Constructor  for MOP class which takes four arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */ 
	public MOP(int iMinLength, int iMaxLength, String strCLength,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_MOP);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}

	/**
	 * Constructor for MOP class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MOP(int iMinLength, int iMaxLength, String strCLength,int iTableNo,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_MOP);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iTableNo = iTableNo;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());		
		}
	}
	/**
	 * Constructor for MOP class which takes two arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MOP(int iComponentType,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_MOP);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for MOP class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MOP(int iComponentType,int iMinLength, int iMaxLength, String strCLength,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_MOP);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for MOP class which takes six arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public MOP(int iComponentType,int iMinLength, int iMaxLength, String strCLength,int ITableNo,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_MOP);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iTableNo = ITableNo;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}



	/**
	 *Sets the MoneyOrPercentageIndicator.
	 *@param strMoneyOrPercentageIndicator Specifies whether the amount is currency or a percentage (AT/PC) 
	 */
	public void setMoneyOrPercentageIndicator(String strMoneyOrPercentageIndicator)
	{
		if(strMoneyOrPercentageIndicator!=null)
			setComponentType(1, strMoneyOrPercentageIndicator);
		else
			setMoneyOrPercentageIndicator((ID)null);
	}


	/**
	 *Sets the MoneyOrPercentageIndicator.
	 *@param objID Specifies whether the amount is currency or a percentage (AT/PC)
	 */
	public void setMoneyOrPercentageIndicator(ID objID)
	{
		setComponentType(1,objID);
	}

	/**
	 *Sets the MoneyOrPercentageQuantity.
	 *@param strMoneyOrPercentageQuantity Specifies the currency or percentage quantity 
	 */
	public void setMoneyOrPercentageQuantity(String strMoneyOrPercentageQuantity)
	{
		if(strMoneyOrPercentageQuantity!=null)
			setComponentType(2, strMoneyOrPercentageQuantity);
		else
			setMoneyOrPercentageQuantity((NM)null);
	}

	/**
	 *Sets the MoneyOrPercentageQuantity.
	 *@param objNM Specifies the currency or percentage quantity
	 */
	public void setMoneyOrPercentageQuantity(NM objNM)
	{
		setComponentType(2,objNM);
	}

	/**
	 *Sets the CurrencyDenomination.
	 *@param strCurrencyDenomination the denomination in which the quantity is expressed 
	 */
	public void setCurrencyDenomination(String strCurrencyDenomination)
	{
		if(strCurrencyDenomination!=null)
			setComponentType(3, strCurrencyDenomination);
		else
			setCurrencyDenomination((ID)null);
	}

	/**
	 *Sets the CurrencyDenomination.
	 *@param objID the denomination in which the quantity is expressed
	 */
	public void setCurrencyDenomination(ID objID)
	{
		setComponentType(3,objID);
	}

	/**
	 * Returns Money or Percentage Indicator
	 * @return ID - data type.
	 */
	public ID getMoneyOrPercentageIndicator()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(1);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Money or Percentage Quantity
	 * @return NM - data type.
	 */
	public NM getMoneyOrPercentageQuantity()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(2);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (NM)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Currency Denomination
	 * @return ID - data type.
	 */
	public ID getCurrencyDenomination()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(3);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * The Method validates the Input value,and if validated properly then returns true.
	 * Here the validetion is based on the compulsory fields for the Datatype. 
	 * @return boolean - true or false.
	 * @throws InvalidDataTypeException - if Invalid values is entered or Mandatory field is missing. 
	 */
	public boolean validate() throws InvalidDataTypeException
	{
		super.validate();
		if(getComponentType(1)==null)
		{
			throw new MissingValueException(this.getClass().getSimpleName() + "Money or Percentage Indicator");
		}	
		if(getComponentType(2)==null)
		{
			throw new MissingValueException(this.getClass().getSimpleName() + "Money or Percentage Quantity");
		}	
		else
			return true;
	}

	/**
	 * This method checks the equality of Object.
	 * @param objObject object of Object class.
	 * @return boolean - shows success or failure of the comparison.
	 */
	public boolean equals(Object objObject)
	{
		if((objObject == null ) || (!(objObject instanceof MOP)))
			return false;

		if(this.getMoneyOrPercentageIndicator() == null)
		{
			if(((MOP)objObject).getMoneyOrPercentageIndicator() != null)
				return false;
		}
		else if(false == (this.getMoneyOrPercentageIndicator().equals(((MOP)objObject).getMoneyOrPercentageIndicator())))
			return false;

		if(this.getMoneyOrPercentageQuantity() == null)
		{
			if(((MOP)objObject).getMoneyOrPercentageQuantity() != null)
				return false;
		}
		else if(false == (this.getMoneyOrPercentageQuantity().equals(((MOP)objObject).getMoneyOrPercentageQuantity())))
			return false;

		if(this.getCurrencyDenomination() == null)
		{
			if(((MOP)objObject).getCurrencyDenomination() != null)
				return false;
		}
		else if(false == (this.getCurrencyDenomination().equals(((MOP)objObject).getCurrencyDenomination())))
			return false;

		return true;
	}
}
